package java.sql;

import java.io.Reader;
import java.io.InputStream;
import java.net.URL;
import java.util.Calendar;
import java.util.Map;
import java.math.BigDecimal;

public interface CallableStatement extends PreparedStatement
{
    public abstract void registerOutParameter(int p0, int p1) throws SQLException;
    
    public abstract void registerOutParameter(int p0, int p1, int p2) throws SQLException;
    
    public abstract boolean wasNull() throws SQLException;
    
    public abstract String getString(int p0) throws SQLException;
    
    public abstract boolean getBoolean(int p0) throws SQLException;
    
    public abstract byte getByte(int p0) throws SQLException;
    
    public abstract short getShort(int p0) throws SQLException;
    
    public abstract int getInt(int p0) throws SQLException;
    
    public abstract long getLong(int p0) throws SQLException;
    
    public abstract float getFloat(int p0) throws SQLException;
    
    public abstract double getDouble(int p0) throws SQLException;
    
    @Deprecated
    public abstract BigDecimal getBigDecimal(int p0, int p1) throws SQLException;
    
    public abstract byte[] getBytes(int p0) throws SQLException;
    
    public abstract Date getDate(int p0) throws SQLException;
    
    public abstract Time getTime(int p0) throws SQLException;
    
    public abstract Timestamp getTimestamp(int p0) throws SQLException;
    
    public abstract Object getObject(int p0) throws SQLException;
    
    public abstract BigDecimal getBigDecimal(int p0) throws SQLException;
    
    public abstract Object getObject(int p0, Map<String, Class<?>> p1) throws SQLException;
    
    public abstract Ref getRef(int p0) throws SQLException;
    
    public abstract Blob getBlob(int p0) throws SQLException;
    
    public abstract Clob getClob(int p0) throws SQLException;
    
    public abstract Array getArray(int p0) throws SQLException;
    
    public abstract Date getDate(int p0, Calendar p1) throws SQLException;
    
    public abstract Time getTime(int p0, Calendar p1) throws SQLException;
    
    public abstract Timestamp getTimestamp(int p0, Calendar p1) throws SQLException;
    
    public abstract void registerOutParameter(int p0, int p1, String p2) throws SQLException;
    
    public abstract void registerOutParameter(String p0, int p1) throws SQLException;
    
    public abstract void registerOutParameter(String p0, int p1, int p2) throws SQLException;
    
    public abstract void registerOutParameter(String p0, int p1, String p2) throws SQLException;
    
    public abstract URL getURL(int p0) throws SQLException;
    
    public abstract void setURL(String p0, URL p1) throws SQLException;
    
    public abstract void setNull(String p0, int p1) throws SQLException;
    
    public abstract void setBoolean(String p0, boolean p1) throws SQLException;
    
    public abstract void setByte(String p0, byte p1) throws SQLException;
    
    public abstract void setShort(String p0, short p1) throws SQLException;
    
    public abstract void setInt(String p0, int p1) throws SQLException;
    
    public abstract void setLong(String p0, long p1) throws SQLException;
    
    public abstract void setFloat(String p0, float p1) throws SQLException;
    
    public abstract void setDouble(String p0, double p1) throws SQLException;
    
    public abstract void setBigDecimal(String p0, BigDecimal p1) throws SQLException;
    
    public abstract void setString(String p0, String p1) throws SQLException;
    
    public abstract void setBytes(String p0, byte[] p1) throws SQLException;
    
    public abstract void setDate(String p0, Date p1) throws SQLException;
    
    public abstract void setTime(String p0, Time p1) throws SQLException;
    
    public abstract void setTimestamp(String p0, Timestamp p1) throws SQLException;
    
    public abstract void setAsciiStream(String p0, InputStream p1, int p2) throws SQLException;
    
    public abstract void setBinaryStream(String p0, InputStream p1, int p2) throws SQLException;
    
    public abstract void setObject(String p0, Object p1, int p2, int p3) throws SQLException;
    
    public abstract void setObject(String p0, Object p1, int p2) throws SQLException;
    
    public abstract void setObject(String p0, Object p1) throws SQLException;
    
    public abstract void setCharacterStream(String p0, Reader p1, int p2) throws SQLException;
    
    public abstract void setDate(String p0, Date p1, Calendar p2) throws SQLException;
    
    public abstract void setTime(String p0, Time p1, Calendar p2) throws SQLException;
    
    public abstract void setTimestamp(String p0, Timestamp p1, Calendar p2) throws SQLException;
    
    public abstract void setNull(String p0, int p1, String p2) throws SQLException;
    
    public abstract String getString(String p0) throws SQLException;
    
    public abstract boolean getBoolean(String p0) throws SQLException;
    
    public abstract byte getByte(String p0) throws SQLException;
    
    public abstract short getShort(String p0) throws SQLException;
    
    public abstract int getInt(String p0) throws SQLException;
    
    public abstract long getLong(String p0) throws SQLException;
    
    public abstract float getFloat(String p0) throws SQLException;
    
    public abstract double getDouble(String p0) throws SQLException;
    
    public abstract byte[] getBytes(String p0) throws SQLException;
    
    public abstract Date getDate(String p0) throws SQLException;
    
    public abstract Time getTime(String p0) throws SQLException;
    
    public abstract Timestamp getTimestamp(String p0) throws SQLException;
    
    public abstract Object getObject(String p0) throws SQLException;
    
    public abstract BigDecimal getBigDecimal(String p0) throws SQLException;
    
    public abstract Object getObject(String p0, Map<String, Class<?>> p1) throws SQLException;
    
    public abstract Ref getRef(String p0) throws SQLException;
    
    public abstract Blob getBlob(String p0) throws SQLException;
    
    public abstract Clob getClob(String p0) throws SQLException;
    
    public abstract Array getArray(String p0) throws SQLException;
    
    public abstract Date getDate(String p0, Calendar p1) throws SQLException;
    
    public abstract Time getTime(String p0, Calendar p1) throws SQLException;
    
    public abstract Timestamp getTimestamp(String p0, Calendar p1) throws SQLException;
    
    public abstract URL getURL(String p0) throws SQLException;
    
    public abstract RowId getRowId(int p0) throws SQLException;
    
    public abstract RowId getRowId(String p0) throws SQLException;
    
    public abstract void setRowId(String p0, RowId p1) throws SQLException;
    
    public abstract void setNString(String p0, String p1) throws SQLException;
    
    public abstract void setNCharacterStream(String p0, Reader p1, long p2) throws SQLException;
    
    public abstract void setNClob(String p0, NClob p1) throws SQLException;
    
    public abstract void setClob(String p0, Reader p1, long p2) throws SQLException;
    
    public abstract void setBlob(String p0, InputStream p1, long p2) throws SQLException;
    
    public abstract void setNClob(String p0, Reader p1, long p2) throws SQLException;
    
    public abstract NClob getNClob(int p0) throws SQLException;
    
    public abstract NClob getNClob(String p0) throws SQLException;
    
    public abstract void setSQLXML(String p0, SQLXML p1) throws SQLException;
    
    public abstract SQLXML getSQLXML(int p0) throws SQLException;
    
    public abstract SQLXML getSQLXML(String p0) throws SQLException;
    
    public abstract String getNString(int p0) throws SQLException;
    
    public abstract String getNString(String p0) throws SQLException;
    
    public abstract Reader getNCharacterStream(int p0) throws SQLException;
    
    public abstract Reader getNCharacterStream(String p0) throws SQLException;
    
    public abstract Reader getCharacterStream(int p0) throws SQLException;
    
    public abstract Reader getCharacterStream(String p0) throws SQLException;
    
    public abstract void setBlob(String p0, Blob p1) throws SQLException;
    
    public abstract void setClob(String p0, Clob p1) throws SQLException;
    
    public abstract void setAsciiStream(String p0, InputStream p1, long p2) throws SQLException;
    
    public abstract void setBinaryStream(String p0, InputStream p1, long p2) throws SQLException;
    
    public abstract void setCharacterStream(String p0, Reader p1, long p2) throws SQLException;
    
    public abstract void setAsciiStream(String p0, InputStream p1) throws SQLException;
    
    public abstract void setBinaryStream(String p0, InputStream p1) throws SQLException;
    
    public abstract void setCharacterStream(String p0, Reader p1) throws SQLException;
    
    public abstract void setNCharacterStream(String p0, Reader p1) throws SQLException;
    
    public abstract void setClob(String p0, Reader p1) throws SQLException;
    
    public abstract void setBlob(String p0, InputStream p1) throws SQLException;
    
    public abstract void setNClob(String p0, Reader p1) throws SQLException;
    
    public abstract <T> T getObject(int p0, Class<T> p1) throws SQLException;
    
    public abstract <T> T getObject(String p0, Class<T> p1) throws SQLException;
    
    default public void setObject(String s, Object o, SQLType sqlType, int n) throws SQLException {
        throw new SQLFeatureNotSupportedException("setObject not implemented");
    }
    
    default public void setObject(String s, Object o, SQLType sqlType) throws SQLException {
        throw new SQLFeatureNotSupportedException("setObject not implemented");
    }
    
    default public void registerOutParameter(int n, SQLType sqlType) throws SQLException {
        throw new SQLFeatureNotSupportedException("registerOutParameter not implemented");
    }
    
    default public void registerOutParameter(int n, SQLType sqlType, int n2) throws SQLException {
        throw new SQLFeatureNotSupportedException("registerOutParameter not implemented");
    }
    
    default public void registerOutParameter(int n, SQLType sqlType, String s) throws SQLException {
        throw new SQLFeatureNotSupportedException("registerOutParameter not implemented");
    }
    
    default public void registerOutParameter(String s, SQLType sqlType) throws SQLException {
        throw new SQLFeatureNotSupportedException("registerOutParameter not implemented");
    }
    
    default public void registerOutParameter(String s, SQLType sqlType, int n) throws SQLException {
        throw new SQLFeatureNotSupportedException("registerOutParameter not implemented");
    }
    
    default public void registerOutParameter(String s, SQLType sqlType, String s2) throws SQLException {
        throw new SQLFeatureNotSupportedException("registerOutParameter not implemented");
    }
}
